# bsd.linux_kmod.mk to build a driver with linux emulation.
# $Id: bsd.linux_kmod.mk,v 1.3 2007/01/29 19:04:30 luigi Exp $
#
# Here you should set the following:
#	.PATH:	driver-specific paths
#	SRCS=	list of (driver) source files that we want to compile.
#	KMOD=	driver name (one word, will be used also elsewhere).
#	CFLAGS=	any driver-specific flags you might need. Often
#		-Ixyz listing all directories with include files.
#
#	Any other driver-specific variables.

# This is the linux-emulation stuff that we need.
# Basically, other .PATH we need, CFLAGS and SRCS, and then
# .include the standard headers.

KLINPATH?= linux_compat	# path of linux compat lib wrt .CURDIR
.PATH: ${.CURDIR}/${KLINPATH}		# location of extra sources

# this is extra stuff that we need.
SRCS+=bus_if.h device_if.h opt_usb.h
SRCS+= ldev_stub.c linux_compat.c

KMODDIR?=/boot/modules
#CFLAGS += -E 
CFLAGS+= -DDRIVER_NAME=${KMOD} -DDEV_NAME=\"video\"
CFLAGS+= -I${KLINPATH}

.include <bsd.kmod.mk>
