*** src/zm_event.cpp.orig	2009-05-08 17:47:19.000000000 +0400
--- src/zm_event.cpp	2010-02-12 09:30:55.556880258 +0300
***************
*** 27,32 ****
--- 27,33 ----
  #include <getopt.h>
  #include <arpa/inet.h>
  #include <glob.h>
+ #include <time.h>
  
  #include "zm.h"
  #include "zm_db.h"
*************** Event::Event( Monitor *p_monitor, struct
*** 61,69 ****
      createNotes( notes );
  
      static char sql[BUFSIZ];
  
      struct tm *stime = localtime( &start_time.tv_sec );
!     snprintf( sql, sizeof(sql), "insert into Events ( MonitorId, Name, StartTime, Width, Height, Cause, Notes ) values ( %d, 'New Event', from_unixtime( %ld ), %d, %d, '%s', '%s' )", monitor->Id(), start_time.tv_sec, monitor->Width(), monitor->Height(), cause.c_str(), notes.c_str() );
      if ( mysql_query( &dbconn, sql ) )
      {
          Error( "Can't insert event: %s", mysql_error( &dbconn ) );
--- 62,72 ----
      createNotes( notes );
  
      static char sql[BUFSIZ];
+     static char start_time_str[32];
  
      struct tm *stime = localtime( &start_time.tv_sec );
!     strftime( start_time_str, sizeof(start_time_str), "%Y-%m-%d %H:%M:%S", localtime((time_t *) &start_time.tv_sec ) );
!     snprintf( sql, sizeof(sql), "insert into Events ( MonitorId, Name, StartTime, Width, Height, Cause, Notes ) values ( %d, 'New Event', from_unixtime( %lld ), %d, %d, '%s', '%s' )", monitor->Id(), (long long) start_time.tv_sec, monitor->Width(), monitor->Height(), cause.c_str(), notes.c_str() );
      if ( mysql_query( &dbconn, sql ) )
      {
          Error( "Can't insert event: %s", mysql_error( &dbconn ) );
*************** Event::Event( Monitor *p_monitor, struct
*** 150,163 ****
  
  Event::~Event()
  {
      if ( frames > last_db_frame )
      {
          struct DeltaTimeval delta_time;
          DELTA_TIMEVAL( delta_time, end_time, start_time, DT_PREC_2 );
  
          Debug( 1, "Adding closing frame %d to DB", frames );
          static char sql[BUFSIZ];
!         snprintf( sql, sizeof(sql), "insert into Frames ( EventId, FrameId, TimeStamp, Delta ) values ( %d, %d, from_unixtime( %ld ), %s%ld.%02ld )", id, frames, end_time.tv_sec, delta_time.positive?"":"-", delta_time.sec, delta_time.fsec );
          if ( mysql_query( &dbconn, sql ) )
          {
              Error( "Can't insert frame: %s", mysql_error( &dbconn ) );
--- 153,168 ----
  
  Event::~Event()
  {
+ 	static char end_time_str[32];
      if ( frames > last_db_frame )
      {
          struct DeltaTimeval delta_time;
          DELTA_TIMEVAL( delta_time, end_time, start_time, DT_PREC_2 );
  
+ 	strftime( end_time_str, sizeof(end_time_str), "%Y-%m-%d %H:%M:%S", localtime( (time_t *) &end_time.tv_sec ) );
          Debug( 1, "Adding closing frame %d to DB", frames );
          static char sql[BUFSIZ];
!         snprintf( sql, sizeof(sql), "insert into Frames ( EventId, FrameId, TimeStamp, Delta ) values ( %d, %d, from_unixtime( %lld ), %s%lld.%02ld )", id, frames, (long long) end_time.tv_sec, delta_time.positive?"":"-", (long long) delta_time.sec, delta_time.fsec );
          if ( mysql_query( &dbconn, sql ) )
          {
              Error( "Can't insert frame: %s", mysql_error( &dbconn ) );
*************** Event::~Event()
*** 170,176 ****
      struct DeltaTimeval delta_time;
      DELTA_TIMEVAL( delta_time, end_time, start_time, DT_PREC_2 );
  
!     snprintf( sql, sizeof(sql), "update Events set Name='%s%d', EndTime = from_unixtime( %ld ), Length = %s%ld.%02ld, Frames = %d, AlarmFrames = %d, TotScore = %d, AvgScore = %d, MaxScore = %d where Id = %d", monitor->EventPrefix(), id, end_time.tv_sec, delta_time.positive?"":"-", delta_time.sec, delta_time.fsec, frames, alarm_frames, tot_score, (int)(alarm_frames?(tot_score/alarm_frames):0), max_score, id );
      if ( mysql_query( &dbconn, sql ) )
      {
          Error( "Can't update event: %s", mysql_error( &dbconn ) );
--- 175,181 ----
      struct DeltaTimeval delta_time;
      DELTA_TIMEVAL( delta_time, end_time, start_time, DT_PREC_2 );
  
!     snprintf( sql, sizeof(sql), "update Events set Name='%s%d', EndTime = from_unixtime( %lld ), Length = %s%lld.%02ld, Frames = %d, AlarmFrames = %d, TotScore = %d, AvgScore = %d, MaxScore = %d where Id = %d", monitor->EventPrefix(), id, (long long) end_time.tv_sec, delta_time.positive?"":"-", (long long) delta_time.sec, delta_time.fsec, frames, alarm_frames, tot_score, (int)(alarm_frames?(tot_score/alarm_frames):0), max_score, id );
      if ( mysql_query( &dbconn, sql ) )
      {
          Error( "Can't update event: %s", mysql_error( &dbconn ) );
*************** bool Event::SendFrameImage( const Image 
*** 276,285 ****
          return( false );
      }
  
!     static int jpg_buffer_size = 0;
!     static unsigned char jpg_buffer[ZM_MAX_IMAGE_SIZE];
  
!     image->EncodeJpeg( jpg_buffer, &jpg_buffer_size, (alarm_frame&&(config.jpeg_alarm_file_quality>config.jpeg_file_quality))?config.jpeg_alarm_file_quality:config.jpeg_file_quality );
  
      static FrameHeader frame_header;
  
--- 281,291 ----
          return( false );
      }
  
!     static long unsigned int jpg_buffer_size = ZM_MAX_IMAGE_SIZE;
!     static unsigned char jpg_buffer_static[ZM_MAX_IMAGE_SIZE];
!     unsigned char * jpg_buffer = jpg_buffer_static;
  
!     image->EncodeJpeg( &jpg_buffer, &jpg_buffer_size, (alarm_frame&&(config.jpeg_alarm_file_quality>config.jpeg_file_quality))?config.jpeg_alarm_file_quality:config.jpeg_file_quality );
  
      static FrameHeader frame_header;
  
*************** bool Event::SendFrameImage( const Image 
*** 321,327 ****
          }
          return( false );
      }
!     Debug( 1, "Wrote frame image, %d bytes", jpg_buffer_size );
  
      return( true );
  }
--- 327,333 ----
          }
          return( false );
      }
!     Debug( 1, "Wrote frame image, %ld bytes", jpg_buffer_size );
  
      return( true );
  }
*************** void Event::AddFrames( int n_frames, Ima
*** 491,497 ****
          DELTA_TIMEVAL( delta_time, *(timestamps[i]), start_time, DT_PREC_2 );
  
          int sql_len = strlen(sql);
!         snprintf( sql+sql_len, sizeof(sql)-sql_len, "( %d, %d, from_unixtime(%ld), %s%ld.%02ld ), ", id, frames, timestamps[i]->tv_sec, delta_time.positive?"":"-", delta_time.sec, delta_time.fsec );
      }
  
      Debug( 1, "Adding %d frames to DB", n_frames );
--- 497,503 ----
          DELTA_TIMEVAL( delta_time, *(timestamps[i]), start_time, DT_PREC_2 );
  
          int sql_len = strlen(sql);
!         snprintf( sql+sql_len, sizeof(sql)-sql_len, "( %d, %d, from_unixtime(%lld), %s%lld.%02ld ), ", id, frames, (long long) timestamps[i]->tv_sec, delta_time.positive?"":"-", (long long) delta_time.sec, delta_time.fsec );
      }
  
      Debug( 1, "Adding %d frames to DB", n_frames );
*************** void Event::AddFrame( Image *image, stru
*** 526,532 ****
  
          Debug( 1, "Adding frame %d to DB", frames );
          static char sql[BUFSIZ];
!         snprintf( sql, sizeof(sql), "insert into Frames ( EventId, FrameId, Type, TimeStamp, Delta, Score ) values ( %d, %d, '%s', from_unixtime( %ld ), %s%ld.%02ld, %d )", id, frames, frame_type, timestamp.tv_sec, delta_time.positive?"":"-", delta_time.sec, delta_time.fsec, score );
          if ( mysql_query( &dbconn, sql ) )
          {
              Error( "Can't insert frame: %s", mysql_error( &dbconn ) );
--- 532,538 ----
  
          Debug( 1, "Adding frame %d to DB", frames );
          static char sql[BUFSIZ];
!         snprintf( sql, sizeof(sql), "insert into Frames ( EventId, FrameId, Type, TimeStamp, Delta, Score ) values ( %d, %d, '%s', from_unixtime( %lld ), %s%lld.%02ld, %d )", id, frames, frame_type, (long long) timestamp.tv_sec, delta_time.positive?"":"-", (long long) delta_time.sec, delta_time.fsec, score );
          if ( mysql_query( &dbconn, sql ) )
          {
              Error( "Can't insert frame: %s", mysql_error( &dbconn ) );
*************** void Event::AddFrame( Image *image, stru
*** 607,613 ****
      }
  }
  
! bool EventStream::loadInitialEventData( int monitor_id, time_t event_time )
  {
      static char sql[BUFSIZ];
  
--- 613,619 ----
      }
  }
  
! bool EventStream::loadInitialEventData( int monitor_id, long event_time )
  {
      static char sql[BUFSIZ];
  
*************** bool EventStream::sendFrame( int delta_u
*** 1172,1178 ****
      {
          static unsigned char temp_img_buffer[ZM_MAX_IMAGE_SIZE];
  
!         int img_buffer_size = 0;
          unsigned char *img_buffer = temp_img_buffer;
  
          bool send_raw = ((scale>=ZM_SCALE_BASE)&&(zoom==ZM_SCALE_BASE));
--- 1178,1184 ----
      {
          static unsigned char temp_img_buffer[ZM_MAX_IMAGE_SIZE];
  
!         long unsigned int img_buffer_size = ZM_MAX_IMAGE_SIZE;
          unsigned char *img_buffer = temp_img_buffer;
  
          bool send_raw = ((scale>=ZM_SCALE_BASE)&&(zoom==ZM_SCALE_BASE));
*************** bool EventStream::sendFrame( int delta_u
*** 1202,1208 ****
              switch( type )
              {
                  case STREAM_JPEG :
!                     send_image->EncodeJpeg( img_buffer, &img_buffer_size );
                      break;
                  case STREAM_RAW :
                      img_buffer = send_image->Buffer();
--- 1208,1214 ----
              switch( type )
              {
                  case STREAM_JPEG :
!                     send_image->EncodeJpeg( &img_buffer, &img_buffer_size );
                      break;
                  case STREAM_RAW :
                      img_buffer = send_image->Buffer();
*************** bool EventStream::sendFrame( int delta_u
*** 1234,1240 ****
                  Fatal( "Unexpected frame type %d", type );
                  break;
          }
!         fprintf( stdout, "Content-Length: %d\r\n\r\n", img_buffer_size );
          if ( fwrite( img_buffer, img_buffer_size, 1, stdout ) != 1 )
          {
              Error( "Unable to send stream frame: %s", strerror(errno) );
--- 1240,1246 ----
                  Fatal( "Unexpected frame type %d", type );
                  break;
          }
!         fprintf( stdout, "Content-Length: %ld\r\n\r\n", img_buffer_size );
          if ( fwrite( img_buffer, img_buffer_size, 1, stdout ) != 1 )
          {
              Error( "Unable to send stream frame: %s", strerror(errno) );
