*** src/zm_image.cpp.orig	2009-05-25 22:04:00.000000000 +0400
--- src/zm_image.cpp	2010-02-15 11:55:43.196155677 +0300
*************** bool Image::ReadRaw( const char *filenam
*** 271,277 ****
  
  	if ( statbuf.st_size != size )
  	{
! 		Error( "Raw file size mismatch, expected %d bytes, found %ld", size, statbuf.st_size );
  		return( false );
  	}
  
--- 271,277 ----
  
  	if ( statbuf.st_size != size )
  	{
! 		Error( "Raw file size mismatch, expected %d bytes, found %lld", size, (long long) statbuf.st_size );
  		return( false );
  	}
  
*************** bool Image::WriteJpeg( const char *filen
*** 442,457 ****
  	return( true );
  }
  
! bool Image::DecodeJpeg( const JOCTET *inbuffer, int inbuffer_size )
  {
  	struct jpeg_decompress_struct *cinfo = jpg_dcinfo;
  
  	if ( !cinfo )
  	{
  		cinfo = jpg_dcinfo = new jpeg_decompress_struct;
  		cinfo->err = jpeg_std_error( &jpg_err.pub );
! 	    jpg_err.pub.error_exit = zm_jpeg_error_exit;
! 	    jpg_err.pub.emit_message = zm_jpeg_emit_message;
  		jpeg_create_decompress( cinfo );
  	}
  
--- 442,467 ----
  	return( true );
  }
  
! bool Image::DecodeJpeg( unsigned char *inbuffer, int inbuffer_size )
  {
+ 	// fix for TRENDNet TV-IP110 series cameras
+ 	unsigned char * b = inbuffer;
+ 	int l = inbuffer_size;
+ 	while( inbuffer_size >= 4 ){
+ 		if( inbuffer[0] == 0xFF && inbuffer[1] == 0xD8 ) break;
+ 		inbuffer++;
+ 		inbuffer_size--;
+ 	}
+ 	if( inbuffer_size <= 4 ) return false;
+ 	
  	struct jpeg_decompress_struct *cinfo = jpg_dcinfo;
  
  	if ( !cinfo )
  	{
  		cinfo = jpg_dcinfo = new jpeg_decompress_struct;
  		cinfo->err = jpeg_std_error( &jpg_err.pub );
! 		jpg_err.pub.error_exit = zm_jpeg_error_exit;
! 		jpg_err.pub.emit_message = zm_jpeg_emit_message;
  		jpeg_create_decompress( cinfo );
  	}
  
*************** bool Image::DecodeJpeg( const JOCTET *in
*** 501,507 ****
  	return( true );
  }
  
! bool Image::EncodeJpeg( JOCTET *outbuffer, int *outbuffer_size, int quality_override ) const
  {
  	if ( config.colour_jpeg_files && colours == 1 )
  	{
--- 511,517 ----
  	return( true );
  }
  
! bool Image::EncodeJpeg( unsigned char **outbuffer, long unsigned int *outbuffer_size, int quality_override ) const
  {
  	if ( config.colour_jpeg_files && colours == 1 )
  	{
*************** void Image::Blend( const Image &image, i
*** 776,782 ****
  
  		while( pdest < (buffer+size) )
  		{
! 			*pdest++ = (*blend_ptr)[*pdest][*psrc++];
  		}
  	}
  	else
--- 786,793 ----
  
  		while( pdest < (buffer+size) )
  		{
! 			*pdest = (*blend_ptr)[*pdest][*psrc++];
! 			pdest++;
  		}
  	}
  	else
