*** src/zm_jpeg.c.orig	2009-03-20 15:07:00.000000000 +0300
--- src/zm_jpeg.c	2010-02-13 11:14:25.742282451 +0300
*************** void zm_jpeg_emit_message( j_common_ptr 
*** 75,111 ****
  	}
  }
  
! /* Expanded data destination object for memory */
  
! typedef struct
! {
!     struct jpeg_destination_mgr pub; /* public fields */
  
!     JOCTET *outbuffer;		/* target buffer */
!     int   *outbuffer_size;
!     JOCTET *buffer;		/* start of buffer */
! } mem_destination_mgr;
  
! typedef mem_destination_mgr * mem_dest_ptr;
  
  #define OUTPUT_BUF_SIZE  4096	/* choose an efficiently fwrite'able size */
  
  /*
   * Initialize destination --- called by jpeg_start_compress
   * before any data is actually written.
   */
  
! static void init_destination (j_compress_ptr cinfo)
  {
!     mem_dest_ptr dest = (mem_dest_ptr) cinfo->dest;
  
!     /* Allocate the output buffer --- it will be released when done with image */
!     dest->buffer = (JOCTET *)(*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_IMAGE, OUTPUT_BUF_SIZE * SIZEOF(JOCTET));
  
!     dest->pub.next_output_byte = dest->buffer;
!     dest->pub.free_in_buffer = OUTPUT_BUF_SIZE;
  
!     *(dest->outbuffer_size) = 0;
  }
  
  
--- 75,140 ----
  	}
  }
  
! #if JPEG_LIB_VERSION < 80
  
! #ifndef HAVE_STDLIB_H		/* <stdlib.h> should declare malloc(),free() */
! extern void * malloc JPP((size_t size));
! extern void free JPP((void *ptr));
! #endif
! 
! 
! /* Expanded data destination object for stdio output */
! 
! typedef struct {
!   struct jpeg_destination_mgr pub; /* public fields */
  
!   FILE * outfile;		/* target stream */
!   JOCTET * buffer;		/* start of buffer */
! } my_destination_mgr;
  
! typedef my_destination_mgr * my_dest_ptr;
  
  #define OUTPUT_BUF_SIZE  4096	/* choose an efficiently fwrite'able size */
  
+ 
+ /* Expanded data destination object for memory output */
+ 
+ typedef struct {
+   struct jpeg_destination_mgr pub; /* public fields */
+ 
+   unsigned char ** outbuffer;	/* target buffer */
+   unsigned long * outsize;
+   unsigned char * newbuffer;	/* newly allocated buffer */
+   JOCTET * buffer;		/* start of buffer */
+   size_t bufsize;
+ } my_mem_destination_mgr;
+ 
+ typedef my_mem_destination_mgr * my_mem_dest_ptr;
+ 
+ 
  /*
   * Initialize destination --- called by jpeg_start_compress
   * before any data is actually written.
   */
  
! METHODDEF(void)
! init_destination (j_compress_ptr cinfo)
  {
!   my_dest_ptr dest = (my_dest_ptr) cinfo->dest;
  
!   /* Allocate the output buffer --- it will be released when done with image */
!   dest->buffer = (JOCTET *)
!       (*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_IMAGE,
! 				  OUTPUT_BUF_SIZE * SIZEOF(JOCTET));
  
!   dest->pub.next_output_byte = dest->buffer;
!   dest->pub.free_in_buffer = OUTPUT_BUF_SIZE;
! }
  
! METHODDEF(void)
! init_mem_destination (j_compress_ptr cinfo)
! {
!   /* no work necessary here */
  }
  
  
*************** static void init_destination (j_compress
*** 132,150 ****
   * write it out when emptying the buffer externally.
   */
  
! static boolean empty_output_buffer (j_compress_ptr cinfo)
  {
!     mem_dest_ptr dest = (mem_dest_ptr) cinfo->dest;
  
!     memcpy( dest->outbuffer+*(dest->outbuffer_size), dest->buffer, OUTPUT_BUF_SIZE );
!     *(dest->outbuffer_size) += OUTPUT_BUF_SIZE;
  
!     dest->pub.next_output_byte = dest->buffer;
!     dest->pub.free_in_buffer = OUTPUT_BUF_SIZE;
  
!     return( TRUE );
  }
  
  /*
   * Terminate destination --- called by jpeg_finish_compress
   * after all data has been written.  Usually needs to flush buffer.
--- 161,212 ----
   * write it out when emptying the buffer externally.
   */
  
! METHODDEF(boolean)
! empty_output_buffer (j_compress_ptr cinfo)
  {
!   my_dest_ptr dest = (my_dest_ptr) cinfo->dest;
  
!   if (JFWRITE(dest->outfile, dest->buffer, OUTPUT_BUF_SIZE) !=
!       (size_t) OUTPUT_BUF_SIZE)
!     ERREXIT(cinfo, JERR_FILE_WRITE);
  
!   dest->pub.next_output_byte = dest->buffer;
!   dest->pub.free_in_buffer = OUTPUT_BUF_SIZE;
  
!   return TRUE;
  }
  
+ METHODDEF(boolean)
+ empty_mem_output_buffer (j_compress_ptr cinfo)
+ {
+   size_t nextsize;
+   JOCTET * nextbuffer;
+   my_mem_dest_ptr dest = (my_mem_dest_ptr) cinfo->dest;
+ 
+   /* Try to allocate new buffer with double size */
+   nextsize = dest->bufsize * 2;
+   nextbuffer = malloc(nextsize);
+ 
+   if (nextbuffer == NULL)
+     ERREXIT1(cinfo, JERR_OUT_OF_MEMORY, 10);
+ 
+   MEMCOPY(nextbuffer, dest->buffer, dest->bufsize);
+ 
+   if (dest->newbuffer != NULL)
+     free(dest->newbuffer);
+ 
+   dest->newbuffer = nextbuffer;
+ 
+   dest->pub.next_output_byte = nextbuffer + dest->bufsize;
+   dest->pub.free_in_buffer = dest->bufsize;
+ 
+   dest->buffer = nextbuffer;
+   dest->bufsize = nextsize;
+ 
+   return TRUE;
+ }
+ 
+ 
  /*
   * Terminate destination --- called by jpeg_finish_compress
   * after all data has been written.  Usually needs to flush buffer.
*************** static boolean empty_output_buffer (j_co
*** 154,169 ****
   * for error exit.
   */
  
! static void term_destination (j_compress_ptr cinfo)
  {
!     mem_dest_ptr dest = (mem_dest_ptr) cinfo->dest;
!     size_t datacount = OUTPUT_BUF_SIZE - dest->pub.free_in_buffer;
  
!     if ( datacount > 0 )
!     {
!         memcpy( dest->outbuffer+*(dest->outbuffer_size), dest->buffer, datacount );
!         *(dest->outbuffer_size) += datacount;
!     }
  }
  
  
--- 216,245 ----
   * for error exit.
   */
  
! METHODDEF(void)
! term_destination (j_compress_ptr cinfo)
  {
!   my_dest_ptr dest = (my_dest_ptr) cinfo->dest;
!   size_t datacount = OUTPUT_BUF_SIZE - dest->pub.free_in_buffer;
  
!   /* Write any data remaining in the buffer */
!   if (datacount > 0) {
!     if (JFWRITE(dest->outfile, dest->buffer, datacount) != datacount)
!       ERREXIT(cinfo, JERR_FILE_WRITE);
!   }
!   fflush(dest->outfile);
!   /* Make sure we wrote the output file OK */
!   if (ferror(dest->outfile))
!     ERREXIT(cinfo, JERR_FILE_WRITE);
! }
! 
! METHODDEF(void)
! term_mem_destination (j_compress_ptr cinfo)
! {
!   my_mem_dest_ptr dest = (my_mem_dest_ptr) cinfo->dest;
! 
!   *dest->outbuffer = dest->buffer;
!   *dest->outsize = dest->bufsize - dest->pub.free_in_buffer;
  }
  
  
*************** static void term_destination (j_compress
*** 173,235 ****
   * for closing it after finishing compression.
   */
  
! void jpeg_mem_dest (j_compress_ptr cinfo, JOCTET *outbuffer, int *outbuffer_size )
  {
!     mem_dest_ptr dest;
  
!     /* The destination object is made permanent so that multiple JPEG images
!      * can be written to the same file without re-executing jpeg_stdio_dest.
!      * This makes it dangerous to use this manager and a different destination
!      * manager serially with the same JPEG object, because their private object
!      * sizes may be different.  Caveat programmer.
!      */
!     if ( cinfo->dest == NULL )
!     {
!         /* first time for this JPEG object? */
!         cinfo->dest = (struct jpeg_destination_mgr *)(*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_PERMANENT, SIZEOF(mem_destination_mgr));
!     }
  
!     dest = (mem_dest_ptr) cinfo->dest;
!     dest->pub.init_destination = init_destination;
!     dest->pub.empty_output_buffer = empty_output_buffer;
!     dest->pub.term_destination = term_destination;
!     dest->outbuffer = outbuffer;
!     dest->outbuffer_size = outbuffer_size;
  }
  
! /* Expanded data source object for memory input */
  
- typedef struct
- {
-     struct jpeg_source_mgr pub;	/* public fields */
  
-     JOCTET * inbuffer;		/* source stream */
-     int    inbuffer_size;
-     int    inbuffer_size_hwm; /* High water mark */
  
!     JOCTET * buffer;		/* start of buffer */
!     boolean start_of_data;	/* have we gotten any data yet? */
! } mem_source_mgr;
  
! typedef mem_source_mgr * mem_src_ptr;
  
  #define INPUT_BUF_SIZE  4096	/* choose an efficiently fread'able size */
  
  /*
   * Initialize source --- called by jpeg_read_header
   * before any data is actually read.
   */
  
! static void init_source (j_decompress_ptr cinfo)
  {
!     mem_src_ptr src = (mem_src_ptr) cinfo->src;
  
!     /* We reset the empty-input-file flag for each image,
!      * but we don't clear the input buffer.
!      * This is correct behavior for reading a series of images from one source.
!      */
!     src->start_of_data = TRUE;
!     src->pub.bytes_in_buffer = 0;
  }
  
  
--- 249,368 ----
   * for closing it after finishing compression.
   */
  
! GLOBAL(void)
! jpeg_stdio_dest (j_compress_ptr cinfo, FILE * outfile)
  {
!   my_dest_ptr dest;
  
!   /* The destination object is made permanent so that multiple JPEG images
!    * can be written to the same file without re-executing jpeg_stdio_dest.
!    * This makes it dangerous to use this manager and a different destination
!    * manager serially with the same JPEG object, because their private object
!    * sizes may be different.  Caveat programmer.
!    */
!   if (cinfo->dest == NULL) {	/* first time for this JPEG object? */
!     cinfo->dest = (struct jpeg_destination_mgr *)
!       (*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_PERMANENT,
! 				  SIZEOF(my_destination_mgr));
!   }
! 
!   dest = (my_dest_ptr) cinfo->dest;
!   dest->pub.init_destination = init_destination;
!   dest->pub.empty_output_buffer = empty_output_buffer;
!   dest->pub.term_destination = term_destination;
!   dest->outfile = outfile;
! }
  
! 
! /*
!  * Prepare for output to a memory buffer.
!  * The caller may supply an own initial buffer with appropriate size.
!  * Otherwise, or when the actual data output exceeds the given size,
!  * the library adapts the buffer size as necessary.
!  * The standard library functions malloc/free are used for allocating
!  * larger memory, so the buffer is available to the application after
!  * finishing compression, and then the application is responsible for
!  * freeing the requested memory.
!  */
! 
! GLOBAL(void)
! jpeg_mem_dest (j_compress_ptr cinfo,
! 	       unsigned char ** outbuffer, unsigned long * outsize)
! {
!   my_mem_dest_ptr dest;
! 
!   if (outbuffer == NULL || outsize == NULL)	/* sanity check */
!     ERREXIT(cinfo, JERR_BUFFER_SIZE);
! 
!   /* The destination object is made permanent so that multiple JPEG images
!    * can be written to the same buffer without re-executing jpeg_mem_dest.
!    */
!   if (cinfo->dest == NULL) {	/* first time for this JPEG object? */
!     cinfo->dest = (struct jpeg_destination_mgr *)
!       (*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_PERMANENT,
! 				  SIZEOF(my_mem_destination_mgr));
!   }
! 
!   dest = (my_mem_dest_ptr) cinfo->dest;
!   dest->pub.init_destination = init_mem_destination;
!   dest->pub.empty_output_buffer = empty_mem_output_buffer;
!   dest->pub.term_destination = term_mem_destination;
!   dest->outbuffer = outbuffer;
!   dest->outsize = outsize;
!   dest->newbuffer = NULL;
! 
!   if (*outbuffer == NULL || *outsize == 0) {
!     /* Allocate initial buffer */
!     dest->newbuffer = *outbuffer = malloc(OUTPUT_BUF_SIZE);
!     if (dest->newbuffer == NULL)
!       ERREXIT1(cinfo, JERR_OUT_OF_MEMORY, 10);
!     *outsize = OUTPUT_BUF_SIZE;
!   }
! 
!   dest->pub.next_output_byte = dest->buffer = *outbuffer;
!   dest->pub.free_in_buffer = dest->bufsize = *outsize;
  }
  
! //--------------------------
  
  
  
! /* Expanded data source object for stdio input */
! 
! typedef struct {
!   struct jpeg_source_mgr pub;	/* public fields */
! 
!   FILE * infile;		/* source stream */
!   JOCTET * buffer;		/* start of buffer */
!   boolean start_of_file;	/* have we gotten any data yet? */
! } my_source_mgr;
  
! typedef my_source_mgr * my_src_ptr;
  
  #define INPUT_BUF_SIZE  4096	/* choose an efficiently fread'able size */
  
+ 
  /*
   * Initialize source --- called by jpeg_read_header
   * before any data is actually read.
   */
  
! METHODDEF(void)
! init_source (j_decompress_ptr cinfo)
  {
!   my_src_ptr src = (my_src_ptr) cinfo->src;
! 
!   /* We reset the empty-input-file flag for each image,
!    * but we don't clear the input buffer.
!    * This is correct behavior for reading a series of images from one source.
!    */
!   src->start_of_file = TRUE;
! }
  
! METHODDEF(void)
! init_mem_source (j_decompress_ptr cinfo)
! {
!   /* no work necessary here */
  }
  
  
*************** static void init_source (j_decompress_pt
*** 266,295 ****
   * the front of the buffer rather than discarding it.
   */
  
! static boolean fill_input_buffer (j_decompress_ptr cinfo)
  {
!     mem_src_ptr src = (mem_src_ptr) cinfo->src;
!     size_t nbytes;
  
!     memcpy( src->buffer, src->inbuffer, (size_t) src->inbuffer_size );
!     nbytes = src->inbuffer_size;
  
!     if ( nbytes <= 0 )
!     {
!         if ( src->start_of_data )	/* Treat empty input file as fatal error */
!             ERREXIT(cinfo, JERR_INPUT_EMPTY);
!         WARNMS(cinfo, JWRN_JPEG_EOF);
!         /* Insert a fake EOI marker */
!         src->buffer[0] = (JOCTET) 0xFF;
!         src->buffer[1] = (JOCTET) JPEG_EOI;
!         nbytes = 2;
!     }
  
!     src->pub.next_input_byte = src->buffer;
!     src->pub.bytes_in_buffer = nbytes;
!     src->start_of_data = FALSE;
  
!   return( TRUE );
  }
  
  
--- 399,447 ----
   * the front of the buffer rather than discarding it.
   */
  
! METHODDEF(boolean)
! fill_input_buffer (j_decompress_ptr cinfo)
  {
!   my_src_ptr src = (my_src_ptr) cinfo->src;
!   size_t nbytes;
  
!   nbytes = JFREAD(src->infile, src->buffer, INPUT_BUF_SIZE);
  
!   if (nbytes <= 0) {
!     if (src->start_of_file)	/* Treat empty input file as fatal error */
!       ERREXIT(cinfo, JERR_INPUT_EMPTY);
!     WARNMS(cinfo, JWRN_JPEG_EOF);
!     /* Insert a fake EOI marker */
!     src->buffer[0] = (JOCTET) 0xFF;
!     src->buffer[1] = (JOCTET) JPEG_EOI;
!     nbytes = 2;
!   }
! 
!   src->pub.next_input_byte = src->buffer;
!   src->pub.bytes_in_buffer = nbytes;
!   src->start_of_file = FALSE;
! 
!   return TRUE;
! }
  
! METHODDEF(boolean)
! fill_mem_input_buffer (j_decompress_ptr cinfo)
! {
!   static JOCTET mybuffer[4];
! 
!   /* The whole JPEG data is expected to reside in the supplied memory
!    * buffer, so any request for more data beyond the given buffer size
!    * is treated as an error.
!    */
!   WARNMS(cinfo, JWRN_JPEG_EOF);
!   /* Insert a fake EOI marker */
!   mybuffer[0] = (JOCTET) 0xFF;
!   mybuffer[1] = (JOCTET) JPEG_EOI;
  
!   cinfo->src->next_input_byte = mybuffer;
!   cinfo->src->bytes_in_buffer = 2;
! 
!   return TRUE;
  }
  
  
*************** static boolean fill_input_buffer (j_deco
*** 305,335 ****
   * buffer is the application writer's problem.
   */
  
! static void skip_input_data (j_decompress_ptr cinfo, long num_bytes)
  {
!     mem_src_ptr src = (mem_src_ptr) cinfo->src;
  
!     /* Just a dumb implementation for now.  Could use fseek() except
!      * it doesn't work on pipes.  Not clear that being smart is worth
!      * any trouble anyway --- large skips are infrequent.
!      */
!     if ( num_bytes > 0 )
!     {
!         while ( num_bytes > (long) src->pub.bytes_in_buffer )
!         {
!             num_bytes -= (long) src->pub.bytes_in_buffer;
!             (void) fill_input_buffer(cinfo);
!             /* note we assume that fill_input_buffer will never return FALSE,
!              * so suspension need not be handled.
!              */
!         }
!         src->pub.next_input_byte += (size_t) num_bytes;
!         src->pub.bytes_in_buffer -= (size_t) num_bytes;
      }
  }
  
  
  /*
   * Terminate source --- called by jpeg_finish_decompress
   * after all data has been read.  Often a no-op.
   *
--- 457,495 ----
   * buffer is the application writer's problem.
   */
  
! METHODDEF(void)
! skip_input_data (j_decompress_ptr cinfo, long num_bytes)
  {
!   struct jpeg_source_mgr * src = cinfo->src;
  
!   /* Just a dumb implementation for now.  Could use fseek() except
!    * it doesn't work on pipes.  Not clear that being smart is worth
!    * any trouble anyway --- large skips are infrequent.
!    */
!   if (num_bytes > 0) {
!     while (num_bytes > (long) src->bytes_in_buffer) {
!       num_bytes -= (long) src->bytes_in_buffer;
!       (void) fill_input_buffer(cinfo);
!       /* note we assume that fill_input_buffer will never return FALSE,
!        * so suspension need not be handled.
!        */
      }
+     src->next_input_byte += (size_t) num_bytes;
+     src->bytes_in_buffer -= (size_t) num_bytes;
+   }
  }
  
  
  /*
+  * An additional method that can be provided by data source modules is the
+  * resync_to_restart method for error recovery in the presence of RST markers.
+  * For the moment, this source module just uses the default resync method
+  * provided by the JPEG library.  That method assumes that no backtracking
+  * is possible.
+  */
+ 
+ 
+ /*
   * Terminate source --- called by jpeg_finish_decompress
   * after all data has been read.  Often a no-op.
   *
*************** static void skip_input_data (j_decompres
*** 338,392 ****
   * for error exit.
   */
  
! static void term_source (j_decompress_ptr cinfo)
  {
!     /* no work necessary here */
  }
  
  
  /*
!  * Prepare for input from a memory stream.
   * The caller must have already opened the stream, and is responsible
   * for closing it after finishing decompression.
   */
  
! void jpeg_mem_src( j_decompress_ptr cinfo, const JOCTET *inbuffer, int inbuffer_size )
  {
!     mem_src_ptr src;
  
!     /* The source object and input buffer are made permanent so that a series
!      * of JPEG images can be read from the same file by calling jpeg_mem_src
!      * only before the first one.  (If we discarded the buffer at the end of
!      * one image, we'd likely lose the start of the next one.)
!      * This makes it unsafe to use this manager and a different source
!      * manager serially with the same JPEG object.  Caveat programmer.
!      */
!     if ( cinfo->src == NULL )
!     {
!   	    /* first time for this JPEG object? */
!         cinfo->src = (struct jpeg_source_mgr *)(*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_PERMANENT, SIZEOF(mem_source_mgr));
!         src = (mem_src_ptr) cinfo->src;
!         src->buffer = (JOCTET *)(*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_PERMANENT, inbuffer_size * SIZEOF(JOCTET));
! 	    src->inbuffer_size_hwm = inbuffer_size;
!     }
!     else
!     {
!         src = (mem_src_ptr) cinfo->src;
! 	    if ( src->inbuffer_size_hwm < inbuffer_size )
! 	    {
!             src->buffer = (JOCTET *)(*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_PERMANENT, inbuffer_size * SIZEOF(JOCTET));
! 	        src->inbuffer_size_hwm = inbuffer_size;
! 	    }
!     }
  
!     src = (mem_src_ptr) cinfo->src;
!     src->pub.init_source = init_source;
!     src->pub.fill_input_buffer = fill_input_buffer;
!     src->pub.skip_input_data = skip_input_data;
!     src->pub.resync_to_restart = jpeg_resync_to_restart; /* use default method */
!     src->pub.term_source = term_source;
!     src->inbuffer = (JOCTET *)inbuffer;
!     src->inbuffer_size = inbuffer_size;
!     src->pub.bytes_in_buffer = 0; /* forces fill_input_buffer on first read */
!     src->pub.next_input_byte = NULL; /* until buffer loaded */
  }
--- 498,582 ----
   * for error exit.
   */
  
! METHODDEF(void)
! term_source (j_decompress_ptr cinfo)
  {
!   /* no work necessary here */
  }
  
  
  /*
!  * Prepare for input from a stdio stream.
   * The caller must have already opened the stream, and is responsible
   * for closing it after finishing decompression.
   */
  
! GLOBAL(void)
! jpeg_stdio_src (j_decompress_ptr cinfo, FILE * infile)
  {
!   my_src_ptr src;
  
!   /* The source object and input buffer are made permanent so that a series
!    * of JPEG images can be read from the same file by calling jpeg_stdio_src
!    * only before the first one.  (If we discarded the buffer at the end of
!    * one image, we'd likely lose the start of the next one.)
!    * This makes it unsafe to use this manager and a different source
!    * manager serially with the same JPEG object.  Caveat programmer.
!    */
!   if (cinfo->src == NULL) {	/* first time for this JPEG object? */
!     cinfo->src = (struct jpeg_source_mgr *)
!       (*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_PERMANENT,
! 				  SIZEOF(my_source_mgr));
!     src = (my_src_ptr) cinfo->src;
!     src->buffer = (JOCTET *)
!       (*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_PERMANENT,
! 				  INPUT_BUF_SIZE * SIZEOF(JOCTET));
!   }
! 
!   src = (my_src_ptr) cinfo->src;
!   src->pub.init_source = init_source;
!   src->pub.fill_input_buffer = fill_input_buffer;
!   src->pub.skip_input_data = skip_input_data;
!   src->pub.resync_to_restart = jpeg_resync_to_restart; /* use default method */
!   src->pub.term_source = term_source;
!   src->infile = infile;
!   src->pub.bytes_in_buffer = 0; /* forces fill_input_buffer on first read */
!   src->pub.next_input_byte = NULL; /* until buffer loaded */
! }
  
! 
! /*
!  * Prepare for input from a supplied memory buffer.
!  * The buffer must contain the whole JPEG data.
!  */
! 
! GLOBAL(void)
! jpeg_mem_src (j_decompress_ptr cinfo,
! 	      unsigned char * inbuffer, unsigned long insize)
! {
!   struct jpeg_source_mgr * src;
! 
!   if (inbuffer == NULL || insize == 0)	/* Treat empty input as fatal error */
!     ERREXIT(cinfo, JERR_INPUT_EMPTY);
! 
!   /* The source object is made permanent so that a series of JPEG images
!    * can be read from the same buffer by calling jpeg_mem_src only before
!    * the first one.
!    */
!   if (cinfo->src == NULL) {	/* first time for this JPEG object? */
!     cinfo->src = (struct jpeg_source_mgr *)
!       (*cinfo->mem->alloc_small) ((j_common_ptr) cinfo, JPOOL_PERMANENT,
! 				  SIZEOF(struct jpeg_source_mgr));
!   }
! 
!   src = cinfo->src;
!   src->init_source = init_mem_source;
!   src->fill_input_buffer = fill_mem_input_buffer;
!   src->skip_input_data = skip_input_data;
!   src->resync_to_restart = jpeg_resync_to_restart; /* use default method */
!   src->term_source = term_source;
!   src->bytes_in_buffer = (size_t) insize;
!   src->next_input_byte = (JOCTET *) inbuffer;
  }
+ 
+ #endif
