*** src/zm_monitor.cpp.orig	2009-06-24 14:22:23.000000000 +0400
--- src/zm_monitor.cpp	2010-02-12 09:19:20.403682016 +0300
***************
*** 43,48 ****
--- 43,49 ----
  #include <sys/mman.h>
  #include <fcntl.h>
  #else // ZM_MEM_MAPPED
+ #include <unistd.h>
  #include <sys/ipc.h>
  #include <sys/shm.h>
  #endif // ZM_MEM_MAPPED
*************** int Monitor::Capture()
*** 2513,2519 ****
              time_t last_read_delta = now - shared_data->last_read_time;
              if ( last_read_delta > (image_buffer_count/approxFps) )
              {
!                 Warning( "Last image read from shared memory %ld seconds ago, zma may have gone away", last_read_delta )
                  shared_data->last_read_index = image_buffer_count;
              }
          }
--- 2514,2520 ----
              time_t last_read_delta = now - shared_data->last_read_time;
              if ( last_read_delta > (image_buffer_count/approxFps) )
              {
!                 Warning( "Last image read from shared memory %lld seconds ago, zma may have gone away", (long long) last_read_delta )
                  shared_data->last_read_index = image_buffer_count;
              }
          }
*************** bool MonitorStream::sendFrame( Image *im
*** 3283,3289 ****
      {
          static unsigned char temp_img_buffer[ZM_MAX_IMAGE_SIZE];
  
!         int img_buffer_size = 0;
          unsigned char *img_buffer = temp_img_buffer;
  
          // Calculate how long it takes to actually send the frame
--- 3284,3290 ----
      {
          static unsigned char temp_img_buffer[ZM_MAX_IMAGE_SIZE];
  
!         long unsigned int img_buffer_size = ZM_MAX_IMAGE_SIZE;
          unsigned char *img_buffer = temp_img_buffer;
  
          // Calculate how long it takes to actually send the frame
*************** bool MonitorStream::sendFrame( Image *im
*** 3294,3300 ****
          switch( type )
          {
              case STREAM_JPEG :
!                 send_image->EncodeJpeg( img_buffer, &img_buffer_size );
                  fprintf( stdout, "Content-Type: image/jpeg\r\n" );
                  break;
              case STREAM_RAW :
--- 3295,3301 ----
          switch( type )
          {
              case STREAM_JPEG :
!                 send_image->EncodeJpeg( &img_buffer, &img_buffer_size );
                  fprintf( stdout, "Content-Type: image/jpeg\r\n" );
                  break;
              case STREAM_RAW :
*************** bool MonitorStream::sendFrame( Image *im
*** 3312,3318 ****
                  Fatal( "Unexpected frame type %d", type );
                  break;
          }
!         fprintf( stdout, "Content-Length: %d\r\n\r\n", img_buffer_size );
          if ( fwrite( img_buffer, img_buffer_size, 1, stdout ) != 1 )
          {
              if ( !zm_terminate )
--- 3313,3319 ----
                  Fatal( "Unexpected frame type %d", type );
                  break;
          }
!         fprintf( stdout, "Content-Length: %ld\r\n\r\n", img_buffer_size );
          if ( fwrite( img_buffer, img_buffer_size, 1, stdout ) != 1 )
          {
              if ( !zm_terminate )
*************** void MonitorStream::runStream()
*** 3638,3645 ****
  
  void Monitor::SingleImage( int scale)
  {
!     int img_buffer_size = 0;
!     static JOCTET img_buffer[ZM_MAX_IMAGE_SIZE];
      Image scaled_image;
      int index = shared_data->last_write_index%image_buffer_count;
      Snapshot *snap = &image_buffer[index];
--- 3639,3647 ----
  
  void Monitor::SingleImage( int scale)
  {
!     long unsigned int img_buffer_size = ZM_MAX_IMAGE_SIZE;
!     static unsigned char img_buffer_static[ZM_MAX_IMAGE_SIZE];
!     unsigned char * img_buffer = img_buffer_static;
      Image scaled_image;
      int index = shared_data->last_write_index%image_buffer_count;
      Snapshot *snap = &image_buffer[index];
*************** void Monitor::SingleImage( int scale)
*** 3655,3663 ****
      {
          TimestampImage( snap_image, snap->timestamp );
      }
!     snap_image->EncodeJpeg( img_buffer, &img_buffer_size );
      
!     fprintf( stdout, "Content-Length: %d\r\n", img_buffer_size );
      fprintf( stdout, "Content-Type: image/jpeg\r\n\r\n" );
      fwrite( img_buffer, img_buffer_size, 1, stdout );
  }
--- 3657,3665 ----
      {
          TimestampImage( snap_image, snap->timestamp );
      }
!     snap_image->EncodeJpeg( &img_buffer, &img_buffer_size );
      
!     fprintf( stdout, "Content-Length: %ld\r\n", img_buffer_size );
      fprintf( stdout, "Content-Type: image/jpeg\r\n\r\n" );
      fwrite( img_buffer, img_buffer_size, 1, stdout );
  }
