*** src/zm_remote_camera_http.cpp.orig	2009-05-28 12:47:59.000000000 +0400
--- src/zm_remote_camera_http.cpp	2010-02-15 14:57:56.183894324 +0300
*************** int RemoteCameraHttp::Connect()
*** 95,105 ****
  			return( -1 );
  		}
  
! 		if ( connect( sd, (struct sockaddr *)&sa, sizeof(sa) ) < 0 )
! 		{
! 			Error( "Can't connect to remote camera: %s", strerror(errno) );
! 			Disconnect();
! 			return( -1 );
  		}
  	}
  	Debug( 3, "Connected to host, socket = %d", sd );
--- 95,109 ----
  			return( -1 );
  		}
  
! 		for(;;){
! 			int r = connect( sd, (struct sockaddr *)&sa, sizeof(sa) );
! 			if( r == 0 ) break;
! 			if ( r < 0 && errno != EINTR )
! 			{
! 				Error( "Can't connect to remote camera: %s", strerror(errno) );
! 				Disconnect();
! 				return( -1 );
! 			}
  		}
  	}
  	Debug( 3, "Connected to host, socket = %d", sd );
*************** int RemoteCameraHttp::ReadData( Buffer &
*** 135,150 ****
  
  	struct timeval temp_timeout = timeout;
  
! 	int n_found = select( sd+1, &rfds, NULL, NULL, &temp_timeout );
! 	if( n_found == 0 )
! 	{
! 		Error( "Select timed out" );
! 		return( -1 );
! 	}
! 	else if ( n_found < 0)
! 	{
! 		Error( "Select error: %s", strerror(errno) );
! 		return( -1 );
  	}
  
  	int total_bytes_to_read = 0;
--- 139,157 ----
  
  	struct timeval temp_timeout = timeout;
  
! 	for(;;){
! 		int n_found = select( sd+1, &rfds, NULL, NULL, &temp_timeout );
! 		if( n_found > 0 ) break;
! 		if( n_found == 0 )
! 		{
! 			Error( "Select timed out" );
! 			return( 0 );
! 		}
! 		if ( n_found < 0 && errno != EINTR )
! 		{
! 			Error( "Select error: %s", strerror(errno) );
! 			return( -1 );
! 		}
  	}
  
  	int total_bytes_to_read = 0;
*************** int RemoteCameraHttp::GetResponse()
*** 420,426 ****
  							int buffer_len = ReadData( buffer );
  							if ( buffer_len < 0 )
  							{
!                                 Error( "Unable to read content" );
  								return( -1 );
  							}
  						}
--- 427,433 ----
  							int buffer_len = ReadData( buffer );
  							if ( buffer_len < 0 )
  							{
!                             					Error( "Unable to read content" );
  								return( -1 );
  							}
  						}
*************** int RemoteCameraHttp::GetResponse()
*** 433,439 ****
  							int buffer_len = ReadData( buffer );
  							if ( buffer_len < 0 )
  							{
!                                 Error( "Unable to read content" );
  								return( -1 );
  							}
  							static RegExpr *content_expr = 0;
--- 440,446 ----
  							int buffer_len = ReadData( buffer );
  							if ( buffer_len < 0 )
  							{
! 				                                Error( "Unable to read content" );
  								return( -1 );
  							}
  							static RegExpr *content_expr = 0;
*************** int RemoteCameraHttp::GetResponse()
*** 574,580 ****
  					int buffer_len = ReadData( buffer );
  					if ( buffer_len < 0 )
  					{
!                         Error( "Unable to read header" );
  						return( -1 );
  					}
  
--- 581,587 ----
  					int buffer_len = ReadData( buffer );
  					if ( buffer_len < 0 )
  					{
! 			                        Error( "Unable to read header" );
  						return( -1 );
  					}
  
*************** int RemoteCameraHttp::GetResponse()
*** 681,687 ****
  						if ( status < 200 || status > 299 )
  						{
  							Error( "Invalid response status %s: %s", status_code, status_mesg );
! 							return( -1 );
  						}
  						Debug( 3, "Got status '%d' (%s), http version %s", status, status_mesg, http_version );
  
--- 688,694 ----
  						if ( status < 200 || status > 299 )
  						{
  							Error( "Invalid response status %s: %s", status_code, status_mesg );
! 							return( status == 503 ? 0 : -1 );
  						}
  						Debug( 3, "Got status '%d' (%s), http version %s", status, status_mesg, http_version );
  
*************** int RemoteCameraHttp::GetResponse()
*** 749,755 ****
  							format = X_RGBZ;
  							state = CONTENT;
  						}
! 						else if ( !strcasecmp( content_type, "multipart/x-mixed-replace" ) )
  						{
  							// Image stream, so start processing
  							if ( !content_boundary[0] )
--- 756,765 ----
  							format = X_RGBZ;
  							state = CONTENT;
  						}
! 						else if ( !strcasecmp( content_type, "multipart/x-mixed-replace" )
! 							// fix for TRENDNet TV-IP110 series cameras
! 							|| !strcasecmp( content_type, "multipart/mixed")
! 						 )
  						{
  							// Image stream, so start processing
  							if ( !content_boundary[0] )
*************** int RemoteCameraHttp::GetResponse()
*** 786,791 ****
--- 796,803 ----
  					subcontent_type_header[0] = '\0';
  					content_length = 0;
  					content_type[0] = '\0';
+ 					// fix for TRENDNet TV-IP110 series cameras
+ 					strcpy(content_type,"image/jpeg");
  				}
  				case SUBHEADERCONT :
  				{
*************** int RemoteCameraHttp::GetResponse()
*** 886,892 ****
  						int buffer_len = ReadData( buffer );
  						if ( buffer_len < 0 )
  						{
!                             Error( "Unable to read subheader" );
  							return( -1 );
  						}
  						state = SUBHEADERCONT;
--- 898,904 ----
  						int buffer_len = ReadData( buffer );
  						if ( buffer_len < 0 )
  						{
! 			                                Error( "Unable to read subheader" );
  							return( -1 );
  						}
  						state = SUBHEADERCONT;
*************** int RemoteCameraHttp::GetResponse()
*** 913,926 ****
  						return( -1 );
  					}
  
! 					if ( format == JPEG && buffer.size() >= 2 )
! 					{
! 						if ( buffer[0] != 0xff || buffer[1] != 0xd8 )
! 						{
! 							Error( "Found bogus jpeg header '%02x%02x'", buffer[0], buffer[1] );
! 							return( -1 );
! 						}
! 					}
  
  					if ( content_length )
  					{
--- 925,938 ----
  						return( -1 );
  					}
  
! 					//if ( format == JPEG && buffer.size() >= 2 )
! 					//{
! 						//if ( buffer[0] != 0xff || buffer[1] != 0xd8 )
! 						//{
! 							//Error( "Found bogus jpeg header '%02x%02x'", buffer[0], buffer[1] );
! 							//return( -1 );
! 						//}
! 					//}
  
  					if ( content_length )
  					{
*************** int RemoteCameraHttp::GetResponse()
*** 930,938 ****
  							int buffer_len = ReadData( buffer );
  							if ( buffer_len < 0 )
  							{
!                                 Error( "Unable to read content" );
  								return( -1 );
  							}
  						}
  						Debug( 3, "Got end of image by length, content-length = %d", content_length );
  					}
--- 942,954 ----
  							int buffer_len = ReadData( buffer );
  							if ( buffer_len < 0 )
  							{
! 				                                Error( "Unable to read content" );
  								return( -1 );
  							}
+ 							if ( buffer_len == 0 ){ // if timeout
+ 								content_length = 0;
+ 								break;
+ 							}
  						}
  						Debug( 3, "Got end of image by length, content-length = %d", content_length );
  					}
*************** int RemoteCameraHttp::GetResponse()
*** 945,951 ****
  							int buffer_size = buffer.size();
  							if ( buffer_len < 0 )
  							{
!                                 Error( "Unable to read content" );
  								return( -1 );
  							}
  							if ( buffer_len )
--- 961,967 ----
  							int buffer_size = buffer.size();
  							if ( buffer_len < 0 )
  							{
! 				                                Error( "Unable to read content" );
  								return( -1 );
  							}
  							if ( buffer_len )
*************** int RemoteCameraHttp::GetResponse()
*** 985,990 ****
--- 1001,1008 ----
  					if ( mode == SINGLE_IMAGE )
  					{
  						state = HEADER;
+ 						// fix for TRENDNet TV-IP201 series cameras
+ 						if( strstr(path.c_str(),"/goform/video") == NULL )
  						Disconnect();
  					}
  					else
*************** int RemoteCameraHttp::GetResponse()
*** 994,1003 ****
  
  					if ( format == JPEG && buffer.size() >= 2 )
  					{
! 						if ( buffer[0] != 0xff || buffer[1] != 0xd8 )
  						{
  							Error( "Found bogus jpeg header '%02x%02x'", buffer[0], buffer[1] );
! 							return( -1 );
  						}
  					}
  
--- 1012,1028 ----
  
  					if ( format == JPEG && buffer.size() >= 2 )
  					{
! 						// fix for TRENDNet TV-IP110 series cameras
! 						int i;
! 						for( i = 0; i + 1 < buffer.size(); i++ )
! 							if( buffer[i] == 0xFF && buffer[i + 1] == 0xD8 ){
! 								i = -1;
! 								break;
! 							}
! 						if ( i >= 0 )
  						{
  							Error( "Found bogus jpeg header '%02x%02x'", buffer[0], buffer[1] );
! 							return( 0 );
  						}
  					}
  
*************** int RemoteCameraHttp::Capture( Image &im
*** 1040,1046 ****
  	int content_length = GetResponse();
  	if ( content_length < 0 )
  	{
!         Error( "Unable to get response" );
  		Disconnect();
  		return( -1 );
  	}
--- 1065,1071 ----
  	int content_length = GetResponse();
  	if ( content_length < 0 )
  	{
! 		Error( "Unable to get response" );
  		Disconnect();
  		return( -1 );
  	}
*************** int RemoteCameraHttp::Capture( Image &im
*** 1048,1058 ****
  	{
  		case JPEG :
  		{
! 			if ( !image.DecodeJpeg( buffer.extract( content_length ), content_length ) )
  			{
!                 Error( "Unable to decode jpeg" );
  				Disconnect();
! 				return( -1 );
  			}
  			break;
  		}
--- 1073,1083 ----
  	{
  		case JPEG :
  		{
! 			if ( content_length <= 4 || !image.DecodeJpeg( buffer.extract( content_length ), content_length ) )
  			{
! 				Error( "Unable to decode jpeg" );
  				Disconnect();
! 				return( 0 );
  			}
  			break;
  		}
*************** int RemoteCameraHttp::Capture( Image &im
*** 1082,1088 ****
  		{
  			Error( "Unexpected image format encountered" );
  			Disconnect();
! 			return( -1 );
  		}
  	}
  	return( 0 );
--- 1107,1113 ----
  		{
  			Error( "Unexpected image format encountered" );
  			Disconnect();
! 			return( 0 );
  		}
  	}
  	return( 0 );
